/* servlet Bug.java created by Jungkee (Jake) Kim
   01/13/2000
*/

import java.io.*;
import java.util.*;
import java.util.Date;

import java.sql.*;

import javax.servlet.*;
import javax.servlet.http.*;

import javax.mail.*;
import javax.mail.internet.*;
import javax.activation.*;

public class Bugtest extends HttpServlet
{
   static final String driver_class = "oracle.jdbc.driver.OracleDriver";
   static final String connect_string = "jdbc:oracle:thin:tango_web/wprost@mira.npac.syr.edu:1521:mira";
   static final String error_log_path = "/export/home/webuser/tango/logs";

   public void doPost (HttpServletRequest req, HttpServletResponse res)
      throws ServletException, IOException
   {      
      String first = req.getParameterValues("first")[0];
      String last = req.getParameterValues("last")[0];
      String email = req.getParameterValues("email")[0];
      String title = req.getParameterValues("title")[0];
      String description = req.getParameterValues("description")[0];
      Date now = new Date();

      String receiver = "jake@npac.syr.edu"; 
      String sender = "tango-bug-system@npac.syr.edu";
      String host = "postoffice.npac.syr.edu";

      String emailBody =
             "This message was automatically generated by Tango Bug Report System.\n" +
             "Please, do not respond to it.\n\n" +
             "The following bug has been reported on " + now + ":\n" +
             "* title: " + title + "\n" +
             "* submitted by: " + first + " " + last + " <" + email + ">\n" +
             "* description:\n" + description + "\n" +
	     "To reach Tango Bug System click the following link:\n" +
	     "   http://crpc1.npac.syr.edu/forms/bug.html   \n" +
	     "To change your profile (i.e. password) click the following link:\n" +
	     "   http://crpc1.npac.syr.edu/forms/tango_dev.html   \n\n" +
	     "username: usually your regular username in NPAC domain\n" +
	     "password: usually the same as your username\n" +
	     "database: npac\n\n" +
             "If you encounter any problems using this system, please contact " +
	     " support@webwisdom.com \n";

      String subject = "A new bug has just arrived ...";

      Properties props = new Properties();
      props.put("mail.smtp.host", host);
      Session session = Session.getDefaultInstance(props, null);

      try {
          Class.forName(driver_class);
          Connection conn = DriverManager.getConnection(connect_string);
          CallableStatement cstmt = conn.prepareCall("{call tango.bug.insertDescription(?,?,?,?,?)}");
          cstmt.setString(1, first);
          cstmt.setString(2, last);
          cstmt.setString(3, email);
          cstmt.setString(4, title);
          cstmt.setString(5, description);
          cstmt.executeQuery();
          cstmt.close();
          conn.close();
          Message msg = new MimeMessage(session);
          msg.setFrom(new InternetAddress(sender));
          InternetAddress[] address = {new InternetAddress(receiver)};
          msg.setRecipients(Message.RecipientType.TO, address);
          msg.setSubject(subject);
          msg.setSentDate(now);
          msg.setText(emailBody);

          Transport.send(msg);

      } catch (Exception e) {
        FileWriter errorLog = new FileWriter(error_log_path + "/" + "Bug.err", true);
        PrintWriter toFile = new PrintWriter(errorLog);
        toFile.println("<BEGIN>");
        toFile.println(now);
        e.printStackTrace(toFile);
        toFile.println(first + ", " + last + ", " + email + ", " + title + ", " + description);
        toFile.println("<END>\n");
        errorLog.close();
      }

      PrintWriter toClient = res.getWriter();

      res.setContentType("text/html");
      toClient.println("<html>");
      toClient.println("<head></head>");
      toClient.println("<body>");
      toClient.println("<H2>Bug Test with Javamail</H2>");
      toClient.println("</body>");
      toClient.println("</html>");
      toClient.close();
   }
}
