/* servlet Download.java created by Sergio Strykowski
   07/10/98
   Modified by Jungkee (Jake) Kim
   01/17/2000
   Bug - no agent loaded - fixed at 01/18/2000
*/

import java.io.*;
import java.util.*;
import java.util.Date;
import java.net.*;

import java.sql.*;

import javax.servlet.*;
import javax.servlet.http.*;


public class Download extends HttpServlet
{
   static final String driver_class = "oracle.jdbc.driver.OracleDriver";
   static final String connect_string = "jdbc:oracle:thin:tango_web/wprost@mira.npac.syr.edu:1521:mira";
   static final String error_log_path = "/export/home/webuser/tango/logs";

   public void doPost (HttpServletRequest req, HttpServletResponse res)
      throws ServletException, IOException
   {      
      String first = req.getParameterValues("first")[0];
      String last = req.getParameterValues("last")[0];
      String street = req.getParameterValues("address1")[0];
      String city = req.getParameterValues("city")[0];
      String state = req.getParameterValues("state")[0];
         if (state.length() > 2) state = "";
      String zip = req.getParameterValues("zip")[0];
      String country = req.getParameterValues("country")[0];
         if (country.equals("NotListed")) country = req.getParameterValues("notlistedcount")[0];
      String email = req.getParameterValues("email")[0];
      String phone = req.getParameterValues("phone")[0];
      String company = req.getParameterValues("company")[0];
      String business = req.getParameterValues("domain")[0];
         if (business.equals("node") || business.equals("none")) business = "";
      String wants_email = "Y";

      String product = req.getParameterValues("product")[0];
         if (product.equals("Product not selected")) product = "";
      String remote_addr = req.getRemoteAddr();
      String remote_host = InetAddress.getByName(remote_addr).getHostName();
      String http_user_agent = req.getHeader("User-Agent");
         if (http_user_agent == null) http_user_agent = "";
      String remote_user = req.getRemoteUser();
         if (remote_user == null) remote_user = "";

      try {
          Class.forName(driver_class);
          Connection conn = DriverManager.getConnection(connect_string);
          CallableStatement cstmt =
             conn.prepareCall("{call tango.download.insertDownloadEntry(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)}");
          cstmt.setString(1, first);
	  cstmt.setString(2, last);
          cstmt.setString(3, street);
	  cstmt.setString(4, city);
	  cstmt.setString(5, state);
	  cstmt.setString(6, zip);
          cstmt.setString(7, country);
	  cstmt.setString(8, email);
          cstmt.setString(9, phone);
	  cstmt.setString(10, company);
          cstmt.setString(11, business);
          cstmt.setString(12, wants_email);
	  cstmt.setString(13, product);
          cstmt.setString(14, remote_host);
	  cstmt.setString(15, remote_addr);
          cstmt.setString(16, http_user_agent);
	  cstmt.setString(17, remote_user);
	  // if (remote_user != null) cstmt.setString(16, remote_user); else cstmt.setString(16, Types.NULL);
          cstmt.executeQuery();
          cstmt.close();
          conn.close();
      } catch (Exception e) {
        FileWriter errorLog = new FileWriter(error_log_path + "/" + "Download.err", true);
        PrintWriter toFile = new PrintWriter(errorLog);
        toFile.println("<BEGIN>");
        Date now = new Date();
        toFile.println(now);
        e.printStackTrace(toFile);
        String plsql = first + ", " + last + ", " + street + ", " + city + ", " + state + ", " + zip + ", " +
                       country + ", " + email + ", " + phone + ", " + company + ", " + business + ", " +
                       now + ", " + product + ", " +
                       remote_host + ", " + remote_addr + ", " + http_user_agent + ", " + remote_user;
        toFile.println(plsql);
        toFile.println("<END>\n");
        errorLog.close();
      }

      PrintWriter toClient = res.getWriter();
      res.setContentType("text/html");
      toClient.println("<html>");
      toClient.println("<head></head>");
      toClient.println("<body>");
      toClient.println("<script>");
      toClient.println("document.location.href=\"http://trurl.npac.syr.edu/tango/downloads/download.html\"");
      toClient.println("</script>");
      toClient.println("</body>");
      toClient.println("</html>");
      toClient.close();
   }
}
