/*
 * Copyright(c) 1997  Unicom Communications, Inc.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for commercial and non-commercial purposes is hereby
 * granted provided that this copyright notice appears in all copies.
 * Please refer to the file "LICENSE" for further copyright and licensing
 * information.
 *
 * Unicom Communications, Inc. disclaims all warranties, whether express
 * or implied, with respect to this software including, without limitation,
 * any warranties of merchantability or fitness for a particular purpose
 * or non-infringement. In no event shall Unicom Communications, Inc. be
 * liable for any damages suffered by licensee as a result of using,
 * modifying or distributing this software or its derivatives.
 */


package unicom.servlet.cgi;

/**
 * Error condition while executing certain CGI servlet code; subclasses
 * RuntimeException because the existing APIs don't allow new exception
 * types to be declared in the "throws" clause.
 *
 * @author   Eric Williams
 * @version  $Id: CgiError.java,v 1.2 1997/04/04 19:59:11 ericw Exp $
 */
public class CgiError extends RuntimeException {

  /**
   * Default constructor.
   */
  public CgiError() {
  }

  /**
   * Construct this exception with the specified error message.
   * @param s  error message
   */
  public CgiError(String s) {
    super(s);
  }

}
