/*
 * Copyright(c) 1997  Unicom Communications, Inc.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for commercial and non-commercial purposes is hereby
 * granted provided that this copyright notice appears in all copies.
 * Please refer to the file "LICENSE" for further copyright and licensing
 * information.
 *
 * Unicom Communications, Inc. disclaims all warranties, whether express
 * or implied, with respect to this software including, without limitation,
 * any warranties of merchantability or fitness for a particular purpose
 * or non-infringement. In no event shall Unicom Communications, Inc. be
 * liable for any damages suffered by licensee as a result of using,
 * modifying or distributing this software or its derivatives.
 */


package unicom.servlet.cgi;
import java.util.*;
import javax.servlet.*;

/**
 * A ServletConfig implementation for servlets invoked through CGI.
 *
 * @author  Eric Williams
 * @author  Matt Angell
 * @verion  $Id: CgiServletConfig.java,v 1.3 1997/06/06 20:56:54 ericw Exp $
 */
public class CgiServletConfig implements ServletConfig {

  /** servlet context */
  CgiServletContext context = null;

  /** initalization properties of this servlet */
  Properties cfgProperties = null;

  /**
   * Construct a new CgiServletConfig with the specified context and
   * servlet init properties.<p>
   *
   * @param ctx  the servlet context
   * @param prop the servlet init properties
   */
  public CgiServletConfig(CgiServletContext ctx, Properties prop) {
    context = ctx;
    cfgProperties = prop;
  }

  /**
   * @return the servlet context
   */
  public ServletContext getServletContext() {
    return context;
  }

  /**
   * @param name the name of the init paramter to return
   * @return the init parameter value for the specified key name
   */
  public String getInitParameter(String name) {
    return cfgProperties.getProperty(name);
  }

  /**
   * @return an enumeration of the servlet init paramters
   */
  public Enumeration getInitParameterNames() {
    return cfgProperties.propertyNames();
  }

}
